#include <stdio.h> /* RTK 2009.1.5 */
#include <stdbool.h>
#include <assert.h>

bool stanje[2];
int stLevih, stDesnih;

void Inicializacija()
{
	stanje[0] = false; stanje[1] = false;
	stLevih = 0; stDesnih = 0;
}

void Izpis()
{
	printf("%d vagonov v levo, %d v desno\n", stLevih, stDesnih);
}

void SpremembaSenzorja(int senzor, bool prekinjen)
{
	printf("SpremembaSenzorja(%d, %s)\n", senzor, prekinjen ? "prekinjen" : "neprekinjen");
	assert(senzor == 1 || senzor == 2);
	assert(prekinjen == ! stanje[senzor - 1]);
	if (! stanje[0] && ! stanje[1])
		if (senzor == 1) stDesnih++; else stLevih++;
	stanje[senzor - 1] = prekinjen;
}

/* Preostanek tega programa ni del reitve, ki jo
   od tekmovalcev zahteva naloga, pa pa je namenjen
   testiranju reitve. */

#include <time.h>
#include <ctype.h>

void Cakaj(double sekund)
{
	clock_t t0 = clock();
	while (clock() - t0 < CLOCKS_PER_SEC * sekund) ;
}

void PosljiVlak(bool vLevo, int stVagonov, double hitrostMs)
{
	const double razmikMedSenzorjema = 1;
	const double razmikMedVagoni = 2;
	const double dolzinaVagona = 10;
	int i;

	printf("Vlak v %s (st. vagonov: %d; hitrost: %g m/s)\n",
		vLevo ? "levo" : "desno", stVagonov, hitrostMs);
	for (i = 0; i < stVagonov; i++)
	{
		SpremembaSenzorja(vLevo ? 2 : 1, true);
		Cakaj(razmikMedSenzorjema / hitrostMs);
		SpremembaSenzorja(vLevo ? 1 : 2, true);
		Cakaj((dolzinaVagona - razmikMedSenzorjema) / hitrostMs);
		SpremembaSenzorja(vLevo ? 2 : 1, false);
		Cakaj(razmikMedSenzorjema / hitrostMs);
		SpremembaSenzorja(vLevo ? 1 : 2, false);
		Cakaj((razmikMedVagoni - razmikMedSenzorjema) / hitrostMs);
	}
}

int main()
{
	char c; int n;

	printf("Simulator zeleznice\n");
	printf("Ukazi: L n = poslji n vagonov v levo; D n = poslji n vagonov v desno\n");
	printf("       R = inicializacija; I = izpis; X = izhod.\n");
	printf("Po vsakem ukazu pritisnite enter.\n\n");
	Inicializacija();
	while (true)
	{
		printf("Vrednosti spremenljivk: stanje = { %s, %s }, stLevih = %d, stDesnih = %d\n",
			stanje[0] ? "true" : "false", stanje[1] ? "true" : "false", stLevih, stDesnih);
		printf("Ukaz?  > ");
		do { if (1 != scanf("%c", &c)) { c = -1; break; } } while (isspace(c));
		if (c < 0) break;

		if (c == 'R' || c == 'r') Inicializacija();
		else if (c == 'I' || c == 'i') Izpis();
		else if (c == 'X' || c == 'x' || c == 'Q' || c == 'q' || c == 'E' || c == 'e') break;
		else if (c == 'L' || c == 'l' || c == 'D' || c == 'd') {
			if (1 != scanf("%d", &n)) {
				printf("Neveljavno stevilo vagonov!\n"); continue; }
			PosljiVlak(c == 'L' || c == 'l', n, 10 + rand() % (100 - 10 + 1)); }
		else { printf("Neznan ukaz: \"%c\".\n", c); }
	}
	return 0;
}
