#include <stdio.h> /* RTK 2009.2.2 */
#include <assert.h>

int PreberiNaslednjoSliko();
void VpisiKoordinateInShrani(double x, double y);

int main()
{
	int t1 = -1, t2, tSlike; double x1 = 0, x2 = 0, y1, y2;
	scanf("%d %lf %lf", &t2, &x2, &y2);
	while ((tSlike = PreberiNaslednjoSliko()) > 0)
	{
		while (t2 > 0 && tSlike >= t2) {
			/* Preberimo naslednjo toko. */
			t1 = t2; x1 = x2; y1 = y2;
			if (3 != scanf("%d %lf %lf", &t2, &x2, &y2)) t2 = -1; }
		/* Zdaj imamo dve toki, za kateri vemo, da naa slika lei
		   med njima: t1 <= tSlike < t2.  e smo na zaetku zaporedja
		   tok (t1 < 0), leve neenakosti seveda ne upotevamo, e
		   pa smo e na koncu zaporedja tok (t2 < 0), pa ne upotevamo
		   desne neenakosti. */
		assert(t1 < 0 || t1 <= tSlike);
		assert(t2 < 0 || t2 > tSlike);
		/* t1 > 0 v naslednji vrstici je pomemben, jaz sem ga najprej spregledal.
		   "t2 < 0 ||" pa v bistvu ni nujen -- e je t2 < 0, to pomeni,
		   da je v (x1, y1) poloaj zadnje toke, v (x2, y2) pa verjetno
		   tudi e vedno, razen e ni zadnji scanf (tisti, ki mu je
		   spodletelo in ni vrnil 0) v teh spremenljivkah esa popackal
		   (npr. e je bil na inputu nek as in x-koordinata, ne pa tudi
		   y-koordinata).  Kakorkoli e, naeloma je varneje, e pustimo
		   "t2 < 0 ||" tudi v pogoju. */
		if (t1 > 0 && (t2 < 0 || tSlike - t1 < t2 - tSlike))
			VpisiKoordinateInShrani(x1, y1);
		else
			VpisiKoordinateInShrani(x2, y2);
	}
	return 0;
}

/* Preostanek programa ni del reitve, ki bi jo zahtevali
   od tekmovalca, ampak je implementacija podprogramov,
   za katere naloga pravi, da lahko njihov obstoj kar
   predpostavimo. */

#include <stdbool.h>

int casiSlik[] = { 21, 25, 29, 32, 35, 37, 59, 60, 61, 64, 65, 66, 81, 82, 83 };
int iSlike = 0, nSlik = sizeof(casiSlik)  / sizeof(casiSlik[0]);
bool shranjena = false;

int PreberiNaslednjoSliko()
{
	if (iSlike > 0) { assert(shranjena); shranjena = false; }
	assert(iSlike <= nSlik);
	if (iSlike == nSlik) { iSlike++; return 0; }
	return casiSlik[iSlike++];
}

void VpisiKoordinateInShrani(double x, double y)
{
	assert(! shranjena);
	assert(iSlike > 0 && iSlike <= nSlik);
	printf("Shrani: slika %d, t = %d, x = %g, y = %g\n",
		iSlike - 1, casiSlik[iSlike - 1], x, y);
	shranjena = true;
}
