/* RTK 2009.3.1 */

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#define MaxN 100000
#define MaxD 100

int main(int argc, char** argv)
{
	FILE *f; int i, n, k, *undo;
	char **besede, **izpis;
	char vrstica[MaxD + 2];

	/* Preberimo tevilo ukazov in pripravimo tabele. */
	f = fopen("undo.in", "rt");
	fscanf(f, "%d", &n);
	besede = (char **) malloc(n * sizeof(char *));
	undo = (int *) malloc(n * sizeof(int));
	/* Preberimo ukaze.  Za i-ti ukaz shranimo besedo v
	   besede[i], e gre za ukaz WRITE; e pa gre za UNDO,
	   shranimo tevilo razveljavljenih korakov v undo[i]. */
	for (i = 0; i < n; i++) {
		fscanf(f, "%s", vrstica);
		if (vrstica[0] == 'U') /* UNDO */
			fscanf(f, "%d", &undo[i]);
		else { /* WRITE */
			undo[i] = -1;
			fscanf(f, "%s", vrstica);
			besede[i] = (char *) malloc(strlen(vrstica) + 1);
			strcpy(besede[i], vrstica); }}
	fclose(f);

	/* Poglejmo, katere besede bo treba izpisati.
	   tevec k pove, koliko besed bo treba izpisati. */
	izpis = (char **) malloc(n * sizeof(char *));
	for (i = n - 1, k = 0; i >= 0; i--)
		if (undo[i] >= 0) i -= undo[i];
		else izpis[k++] = besede[i];

	/* Izpiimo rezultat. */
	f = fopen("undo.out", "wt");
	while (k > 0) fprintf(f, "%s", izpis[--k]);
	fprintf(f, "\n"); fclose(f);

	/* Pospravimo za sabo. */
	for (i = 0; i < n; i++) if (undo[i] < 0) free(besede[i]);
	free(izpis); free(besede); free(undo);
	return 0;
}
